//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property  indicator_buffers 0

//
//
//
//
//

extern int    ChannelInitialPeriod   = 150;
extern int    ChannelInitialWidth    = 50;
extern string ChannelName            = "Channel 1/3.1";
extern color  ChannelColor1          = DeepSkyBlue;
extern color  ChannelColor2          = PaleVioletRed;
extern int    ChannelWidth1          = 2;
extern int    ChannelWidth2          = 1;
extern int    ChannelStyle1          = STYLE_SOLID;
extern int    ChannelStyle2          = STYLE_SOLID;

//
//
//
//
//

double bufferMiu[];
double bufferMid[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferMiu);
   SetIndexBuffer(1,bufferMid);
         IndicatorShortName("regression channel ("+ChannelName+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:
      case REASON_RECOMPILE:   break;
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
      case REASON_ACCOUNT:    ObjectDelete(ChannelName);ObjectDelete(ChannelName+":1");
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double regressionLine[];
int start()
{
   double pipMultiplier = 1; if (Digits==3 || Digits==5) pipMultiplier = 10;
   
      //
      //
      //
      //
      //
      
      string name = ChannelName;
      if (ObjectFind(name)==-1)
          ObjectCreate(name,OBJ_CHANNEL,0,Time[ChannelInitialPeriod-1],Close[ChannelInitialPeriod-1],Time[0],Close[0],Time[ChannelInitialPeriod-1],Close[ChannelInitialPeriod-1]+ChannelInitialWidth*pipMultiplier*Point);
             ObjectSet(name,OBJPROP_COLOR,ChannelColor1);
             ObjectSet(name,OBJPROP_RAY,false);
             ObjectSet(name,OBJPROP_WIDTH,ChannelWidth1);
             ObjectSet(name,OBJPROP_STYLE,ChannelStyle1);

      //
      //
      //
      //
      //

         double   price1    = ObjectGet(name,OBJPROP_PRICE1);
         double   price2    = ObjectGet(name,OBJPROP_PRICE2);
         double   price3    = ObjectGet(name,OBJPROP_PRICE3);
         double   priceDiff = (price1-price3)/3.0;
         datetime time1     = ObjectGet(name,OBJPROP_TIME1);
         datetime time2     = ObjectGet(name,OBJPROP_TIME2);
         datetime time3     = ObjectGet(name,OBJPROP_TIME3);
         int      barShift1 = iBarShift(NULL,0,time1);
         int      barShift3 = iBarShift(NULL,0,time3);
         int      timeDiff  = Period()*60*(barShift3-barShift1)/3.0;
      
            price1 -= priceDiff;
            price2 -= priceDiff;
            price3 += priceDiff;
            time1  -= timeDiff;
            time2  -= timeDiff;
            time3  += timeDiff;

         //
         //
         //
         //
         //
      
         name =  ChannelName+":1";
         if (ObjectFind(name)==-1)
             ObjectCreate(name,OBJ_CHANNEL,0,0,0,0,0,0,0);
                ObjectSet(name,OBJPROP_COLOR,ChannelColor2);
                ObjectSet(name,OBJPROP_RAY,false);
                ObjectSet(name,OBJPROP_PRICE1,price1);
                ObjectSet(name,OBJPROP_PRICE2,price2);
                ObjectSet(name,OBJPROP_PRICE3,price3);
                ObjectSet(name,OBJPROP_TIME1 ,time1);
                ObjectSet(name,OBJPROP_TIME2 ,time2);
                ObjectSet(name,OBJPROP_TIME3 ,time3);
                ObjectSet(name,OBJPROP_WIDTH,ChannelWidth2);
                ObjectSet(name,OBJPROP_STYLE,ChannelStyle2);
                
   //
   //
   //
   //
   //
   
   WindowRedraw();
   return(0);
}